Subject: [OSPF] [OSPFv3] regarding p bit set and FA for NSSA (Type-7) LSAs

From: Veerendranatha Reddy Vallem <[email-masked]>
Date: Tue, 9 Aug 2016 12:34:28 +0000

Hi All,
Can you please provide clarification for following in OSPFv3 NSSA implementation.

As RFC 3101 is considered NSSA RFC for both OSPFv2 and OSPFv3,

Case 1:

As per RFC 3101, 2.4 section, While originating Type-7 LSA, if p -bit is set, then Forwarding address (FA) must be non- zero.

For OSPFv3 case, there may be possible FA  is not available (no global address is configured on any of NSSA interface).
If OSPFv3 receives Type-7 LSA with p bit set but no forwarding address, whether this LSA should be consider as valid and can be used for route calculation?

Case 2:
In section 3.2  , Translating Type-7 LSAs into Type-5 LSAs
Same in OSPFv3, if we received Type-7 LSA with no forwarding address but 'p' bit set, whether ABR is allowed to translate this LSA to Type-5 External LSA?

As per my understanding, if Forwarding address is not available, Type-7 LSA must be originated with no 'p' bit set and no forwarding address. If 'p' bit is set means, it must  always
Carry forwarding address(for OSPFv3, it must be global ipv6 address configured on any of interfaces).

Please let me know whether my understanding is correct or not for OSPFv3, as per RFC 3101.

Regards,
Veerendranath

---

From: "Balaji Ganesh (balagane)" <[email-masked]>
Date: Tue, 9 Aug 2016 14:10:22 +0000

Hi Veera,

Please see inline..

Regards,
Balaji

From: OSPF [mailto:[email-masked]] On Behalf Of Veerendranatha Reddy Vallem
Sent: 09 August 2016 18:04
To: OSPF WG List <[email-masked]>
Subject: [OSPF] [OSPFv3] regarding p bit set and FA for NSSA (Type-7) LSAs

Hi All,

Case 1:

[BALAJI: If the Type-7 LSA has no forwarding address, it does not get translated to Type-5. This is specified in the RFC section 2.3, point 6

      6. Those Type-7 LSAs that are to be translated into Type-5 LSAs

         must have their forwarding address set.

However the LSA is still valid and would be used inside the NSSA area.
]

Case 2:

[BALAJI: No. ABR should not be translating such LSAs without forwarding address. This is again as per section 2.3, point 6 in the RFC.]

[BALAJI: P-bit not being set would explicitly mean that we don't want the LSA to be translated. Probably to keep the redistributed prefixes only within the NSSA area (for whatever reason it may be).
If P-bit is set, it should also have a forwarding address for it to be translated.]

Regards,
Veerendranath

---

From: "Acee Lindem (acee)" <[email-masked]>
Date: Tue, 9 Aug 2016 19:53:58 +0000

Hi Veera, Balaji,

While I was contributor to this RFC ;^), I can see it could use some more normative language to cover these cases where no IPv6 forwarding address is available. I basically agree with Balaji, if the P-bit is to be set in the NSSA-LSA, the LSA MAY be originated w/o a forwarding address (in OSPFv3 forward address encoding is optional). If the P-bit is to be clear in the NSSA-LSA, the NSSA-LSA MUST NOT be originated when no forwarding address is available.

Thanks,
Acee

From: OSPF <[email-masked]<mailto:[email-masked]>> on behalf of "Balaji Ganesh (balagane)" <[email-masked]<mailto:[email-masked]>>
Date: Tuesday, August 9, 2016 at 10:10 AM
To: Veerendranatha Reddy Vallem <[email-masked]<mailto:[email-masked]>>, OSPF WG List <[email-masked]<mailto:[email-masked]>>
Subject: Re: [OSPF] [OSPFv3] regarding p bit set and FA for NSSA (Type-7) LSAs

Hi Veera,

Please see inline..

Regards,
Balaji

From: OSPF [mailto:[email-masked]] On Behalf Of Veerendranatha Reddy Vallem
Sent: 09 August 2016 18:04
To: OSPF WG List <[email-masked]<mailto:[email-masked]>>
Subject: [OSPF] [OSPFv3] regarding p bit set and FA for NSSA (Type-7) LSAs

Hi All,

Case 1:

As per RFC 3101, 2.4 section, While originating Type-7 LSA, if p –bit is set, then Forwarding address (FA) must be non- zero.

Case 2:
In section 3.2  , Translating Type-7 LSAs into Type-5 LSAs
Same in OSPFv3, if we received Type-7 LSA with no forwarding address but ‘p’ bit set, whether ABR is allowed to translate this LSA to Type-5 External LSA?

As per my understanding, if Forwarding address is not available, Type-7 LSA must be originated with no ‘p’ bit set and no forwarding address. If ‘p’ bit is set means, it must  always
Carry forwarding address(for OSPFv3, it must be global ipv6 address configured on any of interfaces).

[BALAJI: P-bit not being set would explicitly mean that we don’t want the LSA to be translated. Probably to keep the redistributed prefixes only within the NSSA area (for whatever reason it may be).
If P-bit is set, it should also have a forwarding address for it to be translated.]

Regards,
Veerendranath

---

From: Veerendranatha Reddy Vallem <[email-masked]>
Date: Wed, 10 Aug 2016 05:05:03 +0000

Thanks to Balaji and Acee for clarification.

Regarding Acee clarification,
I think it is other way. If the “p-bit is not to be set (clear)”, then NSSA LSA may be originated without FA. If the “p bit is to be set”, the NSSA LSA must not be originated when no forwarding address is available. As per section 2.3  in RFC 3101

For an NSSA with no such network the forwarding address
   field may only be filled with an address from one of the its active
   interfaces or 0.0.0.0.  If the P-bit is set, the forwarding address
   must be non-zero; otherwise it may be 0.0.0.0.  If an NSSA requires
   the P-bit be set and a non-zero forwarding address is unavailable,
   then the route's Type-7 LSA is not originated into this NSSA.
Please confirm.

Some OSPFV3 NSSA implementations of different vendors, supported Translation of Type-7 with “no FA” but “p bit is set”, are translating to Type-5 LSAs.
If new implementation strict to do not translate then, it may cause inter-op issues with such implementations.
So whether new implementations are also required to support those LSA translation to make compatible with older ones?

Regards,
Veerendranath

From: Acee Lindem (acee) [mailto:[email-masked]]
Sent: 10 August 2016 01:24
To: Balaji Ganesh (balagane) <[email-masked]>; Veerendranatha Reddy Vallem <[email-masked]>; OSPF WG List <[email-masked]>
Subject: Re: [OSPF] [OSPFv3] regarding p bit set and FA for NSSA (Type-7) LSAs

Hi Veera, Balaji,

Thanks,
Acee

Hi Veera,

Please see inline..

Regards,
Balaji

Hi All,

Case 1:

Case 2:

Regards,
Veerendranath

---

From: "Balaji Ganesh (balagane)" <[email-masked]>
Date: Wed, 10 Aug 2016 09:20:00 +0000

Hi Veerendra,

Please see inline again…

Regards,
Balaji

From: Veerendranatha Reddy Vallem [mailto:[email-masked]]
Sent: 10 August 2016 10:35
To: Acee Lindem (acee) <[email-masked]>; Balaji Ganesh (balagane) <[email-masked]>; OSPF WG List <[email-masked]>
Subject: RE: [OSPF] [OSPFv3] regarding p bit set and FA for NSSA (Type-7) LSAs

>>>[BALAJI: I don’t see any issue in originating an NSSA LSA with P-bit set and without forwarding address, if the implementations do not translate such LSAs.
The think any implementation should not translate such LSAs.
If the LSAs are translated, that would could probably cause suboptimal routing/inter-op issues, especially with 2 or more NSSA ABRs.

Would let Acee confirm on the same.]

Regards,
Veerendranath

From: Acee Lindem (acee) [mailto:[email-masked]]
Sent: 10 August 2016 01:24
To: Balaji Ganesh (balagane) <[email-masked]<mailto:[email-masked]>>; Veerendranatha Reddy Vallem <[email-masked]<mailto:[email-masked]>>; OSPF WG List <[email-masked]<mailto:[email-masked]>>
Subject: Re: [OSPF] [OSPFv3] regarding p bit set and FA for NSSA (Type-7) LSAs

Hi Veera, Balaji,

Thanks,
Acee

Hi Veera,

Please see inline..

Regards,
Balaji

Hi All,

Case 1:

Case 2:

Regards,
Veerendranath

---

From: "Acee Lindem (acee)" <[email-masked]>
Date: Wed, 10 Aug 2016 09:38:54 +0000

Hi Veerendranath,

From: Veerendranatha Reddy Vallem <[email-masked]<mailto:[email-masked]>>
Date: Wednesday, August 10, 2016 at 1:05 AM
To: Acee Lindem <[email-masked]<mailto:[email-masked]>>, "Balaji Ganesh (balagane)" <[email-masked]<mailto:[email-masked]>>, OSPF WG List <[email-masked]<mailto:[email-masked]>>
Subject: RE: [OSPF] [OSPFv3] regarding p bit set and FA for NSSA (Type-7) LSAs

You can certainly claim support for RFC 3101 without supporting this. Like any other proprietary extension, whether you support it or not is dependent on your requirements. The case seems rather weak here since the NSSA ASBR need only have a single interface with an IPv6 global address in the NSSA to use as a forwarding address.

Thanks,
Acee

Regards,
Veerendranath

Hi Veera, Balaji,

Thanks,
Acee

Hi Veera,

Please see inline..

Regards,
Balaji

Hi All,

Case 1:

Case 2:

Regards,
Veerendranath

---

From: Veerendranatha Reddy Vallem <[email-masked]>
Date: Wed, 10 Aug 2016 11:29:22 +0000

Thanks to Acee and Balaji for the clarification.

Regards,
Veerendranath

From: Acee Lindem (acee) [mailto:[email-masked]]
Sent: 10 August 2016 15:09
To: Veerendranatha Reddy Vallem <[email-masked]>; Balaji Ganesh (balagane) <[email-masked]>; OSPF WG List <[email-masked]>
Subject: Re: [OSPF] [OSPFv3] regarding p bit set and FA for NSSA (Type-7) LSAs

Hi Veerendranath,

Thanks,
Acee

Regards,
Veerendranath

Hi Veera, Balaji,

Thanks,
Acee

Hi Veera,

Please see inline..

Regards,
Balaji

Hi All,

Case 1:

Case 2:

Regards,
Veerendranath

---

From: "Acee Lindem (acee)" <[email-masked]>
Date: Wed, 10 Aug 2016 11:34:15 +0000

Hi Balaji,

From: "Balaji Ganesh (balagane)" <[email-masked]<mailto:[email-masked]>>
Date: Wednesday, August 10, 2016 at 5:20 AM
To: Veerendranatha Reddy Vallem <[email-masked]<mailto:[email-masked]>>, Acee Lindem <[email-masked]<mailto:[email-masked]>>, OSPF WG List <[email-masked]<mailto:[email-masked]>>
Subject: RE: [OSPF] [OSPFv3] regarding p bit set and FA for NSSA (Type-7) LSAs

Hi Veerendra,

Please see inline again…

Regards,
Balaji

From: Veerendranatha Reddy Vallem [mailto:[email-masked]]
Sent: 10 August 2016 10:35
To: Acee Lindem (acee) <[email-masked]<mailto:[email-masked]>>; Balaji Ganesh (balagane) <[email-masked]<mailto:[email-masked]>>; OSPF WG List <[email-masked]<mailto:[email-masked]>>
Subject: RE: [OSPF] [OSPFv3] regarding p bit set and FA for NSSA (Type-7) LSAs

I’ve thought about this and I think the only consequence is that a sub-optimal NSSA ABR may be chosen by OSPF routers outside the NSSA since no type-4 summary-LSAs are originated for NSSA ASBRs. I can’t envision a topology where there would be loops.

Thanks,
Acee

Regards,
Veerendranath

Hi Veera, Balaji,

Thanks,
Acee

Hi Veera,

Please see inline..

Regards,
Balaji

Hi All,

Case 1:

Case 2:

Regards,
Veerendranath